## sgsearch-1.2.3.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

set (PROJECT_NAME "sgsearch")
project (${PROJECT_NAME})
set (PROJECT_VERSION "1.2.3")
if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
	set (CMAKE_INSTALL_LIBDIR "lib")
endif()

option(ENABLE_THUNARX "enable Thunar extension" on)

add_subdirectory (po)
add_subdirectory (src)
install (DIRECTORY doc/ DESTINATION doc/${PROJECT_NAME}-${PROJECT_VERSION})

=== Makefile ===
PROJECT = ${shell cat CMakeLists.txt | grep "PROJECT_NAME " | cut -f2 -d\"}
VERSION = ${shell cat CMakeLists.txt | grep "PROJECT_VERSION " | cut -f2 -d\"}

all:
	@echo make compile
	@echo make install
	@echo make uninstall
	@echo make po
	@echo make clean
	@echo make www
	@echo make upload
	@echo make archpack
	@echo make debpack
	@echo make slackpack

compile: build/Makefile src/*
	( cd build; make )

build/Makefile: CMakeLists.txt src/CMakeLists.txt po/CMakeLists.txt
	mkdir -p build
	( cd build; cmake .. -DCMAKE_INSTALL_PREFIX=/usr )

install: compile
	( cd build; sudo make install)

uninstall: build/install_manifest.txt
	( cd build; sudo make uninstall )

po:	build/Makefile
	( cd build; make update_po )
	
clean:
	rm -rf build
	rm -rf www
	rm -f ${PROJECT}*.deb ${PROJECT}*.tar.xz ${PROJECT}*.txz

www: doc/README.md doc/INSTALL.md doc/ChangeLog.md doc/wwwhome.html favicon.png sitegen.json doc/sgsearch-screenshot.png
	haxelib run sitegen

upload: clean www
	cd ..; tar -czvf ${PROJECT}-${VERSION}.tar.gz ${PROJECT}-${VERSION}
	scp ../${PROJECT}-${VERSION}.tar.gz frankendres@ftp.tuxfamily.org:${PROJECT}/${PROJECT}-repository/
	scp -r www/* frankendres@ftp.tuxfamily.org:/home/${PROJECT}/${PROJECT}.tuxfamily.org-web/htdocs/

archpack:
	make clean
	mkdir build
	cd ..; tar -czvf ${PROJECT}-${VERSION}.tar.gz ${PROJECT}-${VERSION}
	cp ../${PROJECT}-${VERSION}.tar.gz build/
	cat distrib/arch/PKGBUILD | sed "s/PKGVER/${VERSION}/" > build/PKGBUILD
	cd build; makepkg
	mv build/${PROJECT}-${VERSION}-*.tar.zst .
	rm -rf build

debpack:
	make compile
	( cd build; make install DESTDIR=pack )
	strip --strip-unneeded build/pack/usr/bin/${PROJECT}
	mv build/pack/usr/doc build/pack/usr/share/doc
	mkdir build/pack/DEBIAN
	cat distrib/debian/control | sed "s/PKGVER/${VERSION}/" > build/pack/DEBIAN/control
	find build/pack -type d -exec chmod 755 {} \;
	sudo chown -R root:root build/pack
	sudo dpkg-deb --build build/pack
	mv build/pack.deb ${PROJECT}_${VERSION}_${shell uname -m}.deb
	sudo rm -rf build

slackpack:
	mkdir -p build
	( cd build; cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_LIBDIR=lib64 ; make )
	( cd build; make install DESTDIR=pack )
	strip --strip-unneeded build/pack/usr/bin/${PROJECT}
	mkdir build/pack/install
	cp distrib/slackware/slack-desc build/pack/install/
	( cd build/pack; makepkg -l y -c y ../../${PROJECT}-${VERSION}-${shell uname -m}-orig.txz )
	sudo rm -rf build

=== po/CMakeLists.txt ===
find_program (XGETTEXT xgettext)
find_program (MSGFMT msgfmt)
find_program (MSGMERGE msgmerge)

add_custom_target (i18n ALL)
add_custom_target (update_po)

file (GLOB PO_FILES *.po)
foreach (PO_FILE ${PO_FILES})
	get_filename_component (LANGCODE ${PO_FILE} NAME_WE)
	set (MO_FILE ${${PROJECT_NAME}_BINARY_DIR}/po/${LANGCODE}.mo)
	add_custom_command (TARGET i18n COMMAND ${MSGFMT} -o ${MO_FILE} ${PO_FILE})
	install (FILES ${MO_FILE} DESTINATION share/locale/${LANGCODE}/LC_MESSAGES RENAME ${PROJECT_NAME}.mo)
endforeach (PO_FILE ${PO_FILES})

set (POT_FILE ${${PROJECT_NAME}_SOURCE_DIR}/po/${PROJECT_NAME}.pot)
file (GLOB C_FILES ${${PROJECT_NAME}_SOURCE_DIR}/src/*.c)
add_custom_command (TARGET update_po COMMAND ${XGETTEXT} -o ${POT_FILE} ${${PROJECT_NAME}_SOURCE_DIR}/src/${PROJECT_NAME}.ui ${C_FILES})
foreach (PO_FILE ${PO_FILES})
	add_custom_command (TARGET update_po COMMAND ${MSGMERGE} --backup none -U ${PO_FILE} ${POT_FILE})
endforeach (PO_FILE ${PO_FILES})

=== src/CMakeLists.txt ===
include (FindPkgConfig)
pkg_check_modules (GTKLIBS REQUIRED gtk+-3.0)
if(ENABLE_THUNARX)
	pkg_check_modules (THUNARX REQUIRED thunarx-3)
endif()

set (LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/share/locale)
set (UI_FILE ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME}/${PROJECT_NAME}.ui)
configure_file (config.h.cmake config.h)
include_directories (${CMAKE_BINARY_DIR}/src)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -rdynamic")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_executable (${PROJECT_NAME} ${PROJECT_NAME}.c)
target_link_libraries (${PROJECT_NAME} ${GTKLIBS_LDFLAGS})
include_directories (${GTKLIBS_INCLUDE_DIRS} ${THUNARX_INCLUDE_DIRS})

if(ENABLE_THUNARX)
	include_directories (${THUNARX_INCLUDE_DIRS})
	add_library (thunar-sgsearch STATIC thunar-sgsearch.c)
	target_link_libraries (thunar-sgsearch ${GTKLIBS_LDFLAGS} ${THUNARX_LDFLAGS})
	add_library (thunar-sgsearch-plugin SHARED thunar-sgsearch-plugin.c)
	target_link_libraries (thunar-sgsearch-plugin thunar-sgsearch ${GTKLIBS_LDFLAGS} ${THUNARX_LDFLAGS})
endif()

install (TARGETS ${PROJECT_NAME} DESTINATION bin)
install (FILES ${PROJECT_NAME}.ui DESTINATION share/${PROJECT_NAME})
install (FILES ${PROJECT_NAME}.desktop DESTINATION share/applications)
if (EXISTS "${${PROJECT_NAME}_SOURCE_DIR}/src/${PROJECT_NAME}.png")
	install (FILES ${PROJECT_NAME}.png DESTINATION share/pixmaps)
	add_custom_target (icons ALL)
	foreach (WXH 16x16 24x24 32x32 48x48 64x64)
		add_custom_command (TARGET icons COMMAND mkdir -p ${${PROJECT_NAME}_BINARY_DIR}/${WXH})
		add_custom_command (TARGET icons COMMAND convert -resize ${WXH} ${${PROJECT_NAME}_SOURCE_DIR}/src/${PROJECT_NAME}.png ${${PROJECT_NAME}_BINARY_DIR}/${WXH}/${PROJECT_NAME}.png)
		install (FILES ${${PROJECT_NAME}_BINARY_DIR}/${WXH}/${PROJECT_NAME}.png DESTINATION share/icons/hicolor/${WXH}/apps/)
	endforeach()
endif()
if (EXISTS "${${PROJECT_NAME}_SOURCE_DIR}/src/${PROJECT_NAME}.svg")
	install (FILES ${PROJECT_NAME}.svg DESTINATION share/icons/hicolor/scalable/apps/)
endif()
if(ENABLE_THUNARX)
	install (TARGETS thunar-sgsearch-plugin DESTINATION ${CMAKE_INSTALL_LIBDIR}/thunarx-3)
endif()

add_custom_target (uninstall)
add_custom_command (TARGET uninstall COMMAND xargs rm -f < ${CMAKE_BINARY_DIR}/install_manifest.txt)
add_custom_command (TARGET uninstall COMMAND rmdir ${CMAKE_INSTALL_PREFIX}/doc/${PROJECT_NAME}-${PROJECT_VERSION})
add_custom_command (TARGET uninstall COMMAND rmdir ${CMAKE_INSTALL_PREFIX}/share/${PROJECT_NAME})
if(ENABLE_THUNARX)
	add_custom_command (TARGET uninstall COMMAND rmdir --ignore-fail-on-non-empty ${CMAKE_INSTALL_PREFIX}/lib/thunarx-3)
endif()

=== distrib/arch/PKGBUILD ===
pkgname=sgsearch
pkgver=PKGVER
pkgrel=1
pkgdesc='GTK search utility and Thunar extension.'
arch=('x86_64')
url='sgsearch.tuxfamily.org'
license=('CeCILL')
depends=()
source=($pkgname-$pkgver.tar.gz)
md5sums=(SKIP)

build() {
	cd $pkgname-$pkgver
	mkdir -p build
	cd build
	cmake .. -DCMAKE_INSTALL_PREFIX=/usr
	make
}

package() {
    cd $pkgname-$pkgver/build
    make install DESTDIR="$pkgdir"
    mkdir -p "$pkgdir"/usr/share/doc
    mv "$pkgdir"/usr/doc/$pkgname-$pkgver "$pkgdir"/usr/share/doc/
    install -Dm644 "$srcdir"/$pkgname-$pkgver/doc/License_CeCILL_V2.1-en.txt "$pkgdir"/usr/share/licenses/$pkgname/LICENSE
}

=== distrib/debian/control ===
Package: sgsearch
Version: PKGVER
Architecture: amd64
Depends: libgtk-3-0
Maintainer: Frank Endres <frankendres@tuxfamily.org>
Description: GTK search utility and Thunar extension
